﻿using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Linq;

namespace Netmash.Security.Authentication.Tuitio.Models
{
    internal class ClaimCollection : Dictionary<string, object>
    {
        public void TryAddClaim(object value, params string[] keys)
        {
            if (keys.Any(z => string.IsNullOrEmpty(z)))
                throw new Exception($"All keys must have value.");

            if (value == null)
                return;

            var isPrimitive = value.GetType().IsPrimitive;
            if (!isPrimitive)
            {
                value = JsonConvert.SerializeObject(value);
            }

            foreach (string key in keys)
                Add(key, value);
        }

        public void TryAddRange(Dictionary<string, string> claims, Action<string, string> notifyKeyExistence = null)
        {
            if (claims == null || !claims.Any())
                return;

            foreach (var claim in claims)
            {
                if (ContainsKey(claim.Key))
                {
                    notifyKeyExistence?.Invoke(claim.Key, claim.Value);
                    continue;
                }
                Add(claim.Key, claim.Value);
            }
        }
    }
}
